if(select(2, UnitClass('player')) ~= 'DEATHKNIGHT') then return; end

-- Main variables
local frame_locked = 1;
local current_time = GetTime();
local new_time = GetTime();
local delta_time = 0;
local function calculate_delta_time()
	current_time = GetTime();
	delta_time = current_time - new_time;
	new_time = current_time;
end

local frame_alpha = 1;

local frost_fever_id = 55095;
local blood_plague_id = 55078;
local blood_presence_id = 48263;
local frost_presence_id = 48266;
local unholy_presence_id = 48265;
local killing_machine_id = 51128;
local soul_reaper_ids = { 130735, 130736, 114866 };
local blood_tap_id = 45529;
local blood_charge_id = 114851;

-- Create main frames
local umber_drag_frame = CreateFrame("Frame", "Backgroundframe", UIParent);
umber_drag_frame:SetPoint("CENTER", umb_x, umb_y);
umber_drag_frame:SetWidth(1);
umber_drag_frame:SetHeight(1);

local umber_main_frame = CreateFrame("Frame", nil, UIParent);
umber_main_frame:SetPoint("CENTER", umber_drag_frame, "CENTER", 0, 0);
umber_main_frame:SetWidth(1);
umber_main_frame:SetHeight(1);

local umber_frame = {};
function umber_frame:create(name, width, height)
	local self = {};
	self.name = name;
	self.width = width;
	self.height = height;
	self.frame = CreateFrame("Frame", "Backgroundframe", umber_main_frame);
	return self;
end

local function get_frame_enabled(name)
	if umb_data["frame_"..name.."_enabled"] == nil then
		umb_data["frame_"..name.."_enabled"] = true;
		return true;
	else
		return umb_data["frame_"..name.."_enabled"];
	end
end
local function get_frame_size(name)
	if umb_data["frame_"..name.."_size"] == nil then
		umb_data["frame_"..name.."_size"] = 1;
		return 1;
	else
		return umb_data["frame_"..name.."_size"];
	end
end
local function set_frame_enabled(name, value)
	if value == true or value == false then
		umb_data["frame_"..name.."_enabled"] = value;
	end
end
local function set_frame_size(name, value)
	if tonumber(value) ~= nil then
		umb_data["frame_"..name.."_size"] = value;
	end
end

local frames = {};
frames[table.getn(frames) + 1] = umber_frame:create("targetname", 120, 12);
frames[table.getn(frames) + 1] = umber_frame:create("diseases", 64, 16);
frames[table.getn(frames) + 1] = umber_frame:create("target", 120, 20);
frames[table.getn(frames) + 1] = umber_frame:create("runes", 120, 24);
frames[table.getn(frames) + 1] = umber_frame:create("health", 120, 12);
frames[table.getn(frames) + 1] = umber_frame:create("runic", 120, 12);
frames[table.getn(frames) + 1] = umber_frame:create("swingtimer", 120, 8);
frames[table.getn(frames) + 1] = umber_frame:create("bloodtap", 32, 16);

local function get_frame(name)
	for i = 1, table.getn(frames) do
		if frames[i].name == name then
			return i;
		end
	end
	return -1;
end

local function umber_setup()
	frame_creation_height = 0;
	
	if umb_x == nil then umb_x = 0; end
	if umb_y == nil then umb_y = 0; end
	if umb_data == nil then umb_data = {}; end
	if umb_combat == nil then umb_combat = false; end
	if umb_soulreaper == nil then umb_soulreaper = true; end
	if umb_timers == nil then umb_timers = false; end
	
	if umb_combat == 1 then frame_alpha = 1; else frame_alpha = 0; end
	
	for i = 1, table.getn(frames) do
		frames[i].frame:SetPoint("TOP", umber_main_frame, "TOP", 0, frame_creation_height);
		frame_creation_height = frame_creation_height - frames[i].height;
		frames[i].frame:SetWidth(frames[i].width);
		frames[i].frame:SetHeight(frames[i].height);
		frames[i].frame:SetFrameLevel(15);
		
		if umb_data["frame_"..frames[i].name.."_enabled"] == nil then
			umb_data["frame_"..frames[i].name.."_enabled"] = true;
			umb_data["frame_"..frames[i].name.."_size"] = 1;
		end
	end
end

-- Components
local function update_alpha()
	if umb_combat == true then
		if UnitAffectingCombat("player") == 1 or frame_locked == 0 then
			frame_alpha = frame_alpha + delta_time * 5;
		else
			frame_alpha = frame_alpha - delta_time;
		end
	else
		frame_alpha = frame_alpha + delta_time * 5;
	end
	
	if frame_alpha < 0 then frame_alpha = 0; end
	if frame_alpha > 1 then frame_alpha = 1; end
	
	umber_main_frame:SetAlpha(frame_alpha);
end

local function format_big_number(value)
	if(value > 99999999) then return math.floor(value / 1000000).." M"; end
	if(value > 99999) then return math.floor(value / 1000).." K"; end
	return value;
end
local function format_percentage_number(value, maximum)
	if value == 0 or maximun == 0 then return 0; end
	return (floor((value / (maximum / 100)) * 10 ^ 0 + 0.5 ) / 10 ^ 0);
end

local disease_ff_frame = nil;
local disease_ff_texture = nil;
local disease_ff_text = nil;
local disease_ff_cd = nil;
local disease_bp_frame = nil;
local disease_bp_texture = nil;
local disease_bp_text = nil;
local disease_bp_cd = nil;
local function setup_diseases()
	if disease_ff_frame == nil then
		
		base_frame = frames[get_frame("diseases")];
		
		disease_ff_frame = CreateFrame("Frame", "Backgroundframe", base_frame.frame);
		disease_ff_frame:SetPoint("CENTER", base_frame.frame, "CENTER", -base_frame.height / 2, 0);
		disease_ff_frame:SetWidth(base_frame.height); 
		disease_ff_frame:SetHeight(base_frame.height);
		disease_ff_texture = disease_ff_frame:CreateTexture("ARTWORK");
		disease_ff_texture:SetAllPoints();
		disease_ff_texture:SetTexture("Interface\\Icons\\spell_deathknight_frostfever");
		disease_ff_texture:SetAlpha(1);
		disease_ff_text = disease_ff_frame:CreateFontString("Target Name", "ARTWORK", "GameFontNormalSmall");
		disease_ff_text:SetPoint("CENTER", disease_ff_frame, "CENTER", -base_frame.height, 0);
		disease_ff_text:SetText(" ");
		disease_ff_cd = CreateFrame("Cooldown", "FFCD", disease_ff_frame, "CooldownFrameTemplate");
		disease_ff_cd:SetReverse(true);

		disease_bp_frame = CreateFrame("Frame", "Backgroundframe", base_frame.frame);
		disease_bp_frame:SetPoint("CENTER", base_frame.frame, "CENTER", base_frame.height / 2, 0);
		disease_bp_frame:SetWidth(base_frame.height); 
		disease_bp_frame:SetHeight(base_frame.height);
		disease_bp_texture = disease_bp_frame:CreateTexture("ARTWORK");
		disease_bp_texture:SetAllPoints();
		disease_bp_texture:SetTexture("Interface\\Icons\\spell_deathknight_bloodplague"); 
		disease_bp_texture:SetAlpha(1);
		disease_bp_text = disease_bp_frame:CreateFontString("Target Name", "ARTWORK", "GameFontNormalSmall");
		disease_bp_text:SetPoint("CENTER", disease_bp_frame, "CENTER", base_frame.height, 0);
		disease_bp_text:SetText(" ");
		disease_bp_cd = CreateFrame("Cooldown", "BPCD", disease_bp_frame, "CooldownFrameTemplate");
		disease_bp_cd:SetReverse(true);
		
	end
end
local function update_diseases()
	setup_diseases();
	
	disease_ff_texture:SetAlpha(0.1);
	disease_ff_text:SetText(" ");
	disease_ff_cd:SetCooldown(0, 0);
		
	disease_bp_texture:SetAlpha(0.1);
	disease_bp_text:SetText(" ");
	disease_bp_cd:SetCooldown(0, 0);
	
	i = 1;
	while true do
		local name, _, _, _, _, dur, exp, _, _, _, id = UnitDebuff("target", i, "PLAYER");
		if name then
			if id == frost_fever_id then
				disease_ff_texture:SetAlpha(1);
				disease_ff_text:SetText(string.format("%d", exp - GetTime()));
				disease_ff_cd:SetCooldown(exp - dur, dur, true);
			end
			if id == blood_plague_id then
				disease_bp_texture:SetAlpha(1);
				disease_bp_text:SetText(string.format("%d", exp - GetTime()));
				disease_bp_cd:SetCooldown(exp - dur, dur, true);
			end
		else
			break;
		end
		i = i + 1;
	end
end

local target_health_frame = nil;
local target_health_background = nil;
local target_health_bar = nil;
local target_health_text = nil;
local target_health_perc = nil;
local target_absorb_frame = nil;
local target_absorb_texture = nil;
local target_absorb_bar = nil;
local target_overabsorb_frame = nil;
local target_overabsorb_texture = nil;
local target_energy_frame = nil;
local target_energy_background = nil;
local target_energy_bar = nil;
local target_energy_text = nil;
local target_energy_perc = nil;
local target_level_text = nil;
local target_name_frame = nil;
local target_name_text = nil;
local function setup_target()
	if target_health_frame == nil then
		
		base_frame = frames[get_frame("target")];
		
		target_health_frame = CreateFrame("Frame", nil, base_frame.frame);
		target_health_frame:SetPoint("TOP", base_frame.frame, "TOP", 0, 0);
		target_health_frame:SetWidth(base_frame.width); 
		target_health_frame:SetHeight(base_frame.height / 2);
		
		target_health_background = target_health_frame:CreateTexture("ARTWORK");
		target_health_background:SetAllPoints();
		target_health_background:SetTexture(0.4, 0, 0);
		target_health_background:SetAlpha(0.4);
		
		target_absorb_bar = CreateFrame("StatusBar", nil, target_health_frame);
		target_absorb_bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
		target_absorb_bar:GetStatusBarTexture():SetHorizTile(false);
		target_absorb_bar:SetMinMaxValues(0, 100);
		target_absorb_bar:SetWidth(base_frame.width);
		target_absorb_bar:SetHeight(base_frame.height / 2);
		target_absorb_bar:SetPoint("CENTER", target_health_frame, "CENTER", 0, 0); 
		target_absorb_bar:SetStatusBarColor(1, 1, 1);
		target_absorb_bar:SetFrameLevel(19);
		
		target_absorb_frame = CreateFrame("Frame", nil, target_health_frame);
		target_absorb_frame:SetPoint("TOP", target_health_frame, "TOP", 0, 0);
		target_absorb_frame:SetWidth(base_frame.width); 
		target_absorb_frame:SetHeight(base_frame.height / 2);
		target_absorb_frame:SetFrameLevel(20);
		
		target_absorb_texture = target_absorb_frame:CreateTexture("ARTWORK");
		target_absorb_texture:SetAllPoints();
		target_absorb_texture:SetTexture("Interface\\RaidFrame\\Shield-Overlay", true);
		target_absorb_texture:SetTexCoord(0, -3, 0, 2);
		
		target_overabsorb_frame = CreateFrame("Frame", nil, target_health_frame);
		target_overabsorb_frame:SetPoint("TOPRIGHT", target_health_frame, "TOPRIGHT", 3, 0);
		target_overabsorb_frame:SetWidth(16); 
		target_overabsorb_frame:SetHeight(base_frame.height / 2);
		target_overabsorb_frame:SetFrameLevel(22);
		
		target_overabsorb_texture = target_overabsorb_frame:CreateTexture("ARTWORK");
		target_overabsorb_texture:SetAllPoints();
		target_overabsorb_texture:SetTexture("Interface\\RaidFrame\\Absorb-Overabsorb");
		target_overabsorb_texture:SetBlendMode("ADD");
		
		target_health_bar = CreateFrame("StatusBar", nil, target_health_frame);
		target_health_bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
		target_health_bar:GetStatusBarTexture():SetHorizTile(false);
		target_health_bar:SetMinMaxValues(0, 100);
		target_health_bar:SetWidth(base_frame.width);
		target_health_bar:SetHeight(base_frame.height / 2);
		target_health_bar:SetPoint("CENTER", target_health_frame, "CENTER", 0, 0); 
		target_health_bar:SetStatusBarColor(0.6, 0, 0);
		target_health_bar:SetFrameLevel(21);
		
		target_health_text = target_health_bar:CreateFontString("Runic Power Number", "ARTWORK", "TextStatusBarText");
		target_health_text:SetPoint("CENTER", target_health_bar, "CENTER", 0, 0);
		target_health_text:SetText(0);
		
		target_health_perc = target_health_bar:CreateFontString("Hit Points Percentage", "ARTWORK", "GameFontNormalSmall");
		target_health_perc:SetPoint("CENTER", target_health_bar, "CENTER", base_frame.width / 2 + 15, 0);
		target_health_perc:SetText(0);
		
		target_level_text = target_health_bar:CreateFontString("Hit Points Percentage", "ARTWORK", "GameFontNormalSmall");
		target_level_text:SetPoint("CENTER", target_health_bar, "CENTER", -base_frame.width / 2 - 16, 0);
		target_level_text:SetText(0);
		
		target_energy_frame = CreateFrame("Frame", nil, base_frame.frame);
		target_energy_frame:SetPoint("TOP", base_frame.frame, "TOP", 0, -base_frame.height / 2);
		target_energy_frame:SetWidth(base_frame.width); 
		target_energy_frame:SetHeight(base_frame.height / 2);
		
		target_energy_background = target_energy_frame:CreateTexture("ARTWORK");
		target_energy_background:SetAllPoints();
		target_energy_background:SetTexture(0.4, 0.4, 0.4);
		target_energy_background:SetAlpha(0.2);
		
		target_energy_bar = CreateFrame("StatusBar", nil, target_energy_frame);
		target_energy_bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
		target_energy_bar:GetStatusBarTexture():SetHorizTile(false);
		target_energy_bar:SetMinMaxValues(0, 100);
		target_energy_bar:SetWidth(base_frame.width);
		target_energy_bar:SetHeight(base_frame.height / 2);
		target_energy_bar:SetPoint("CENTER", target_energy_frame, "CENTER", 0, 0); 
		target_energy_bar:SetStatusBarColor(0.6, 0.6, 0.6);
		
		target_energy_text = target_energy_bar:CreateFontString("Runic Power Number", "ARTWORK", "TextStatusBarText");
		target_energy_text:SetPoint("CENTER", target_energy_bar, "CENTER", 0, 0);
		target_energy_text:SetText(0);
		
		target_energy_perc = target_energy_bar:CreateFontString("Hit Points Percentage", "ARTWORK", "GameFontNormalSmall");
		target_energy_perc:SetPoint("CENTER", target_energy_bar, "CENTER", base_frame.width / 2 + 15, 0);
		target_energy_perc:SetText(0);
		
		name_frame = frames[get_frame("targetname")];
		set_frame_size("targetname", get_frame_size("target"));
		
		target_name_frame = CreateFrame("Frame", nil, name_frame.frame);
		target_name_frame:SetPoint("TOP", name_frame.frame, "TOP", 0, 0);
		target_name_frame:SetWidth(name_frame.width); 
		target_name_frame:SetHeight(name_frame.height);
		
		target_name_text = target_name_frame:CreateFontString("Runic Power Number", "ARTWORK", "GameFontNormalSmall");
		target_name_text:SetPoint("CENTER", target_name_frame, "CENTER", 0, 0);
		target_name_text:SetText(0);
	end
end
local function update_target()
	setup_target();
	
	target_health_text:SetText(""..format_big_number(UnitHealth("target")).." / "..format_big_number(UnitHealthMax("target")).."");
	target_health_bar:SetMinMaxValues(0, UnitHealthMax("target"));
	target_health_bar:SetValue(UnitHealth("target"));
	
	
	
	if UnitPowerMax("target") > 0 then
		target_energy_text:SetText(""..format_big_number(UnitPower("target")).." / "..format_big_number(UnitPowerMax("target")).."");
		target_energy_bar:SetMinMaxValues(0, UnitPowerMax("target"));
		target_energy_bar:SetValue(UnitPower("target"));
		
		power_type, power_token = UnitPowerType("target");
		
		r = 0.4; g = 0.4; b = 0.4;
		if PowerBarColor[power_type] ~= nil then
			r = PowerBarColor[power_type]["r"];
			g = PowerBarColor[power_type]["g"];
			b = PowerBarColor[power_type]["b"];
		end
		
		target_energy_background:SetTexture(r, g, b);
		target_energy_bar:SetStatusBarColor(r, g, b);
	else
		target_energy_text:SetText("");
		target_energy_bar:SetValue(0);
		target_energy_background:SetTexture(0.4, 0.4, 0.4);
		target_energy_bar:SetStatusBarColor(0.6, 0.6, 0.6);
	end
	
	target_health_perc:SetText("");
	target_energy_perc:SetText("");
	
	if UnitHealthMax("target") > 0 then
		if UnitHealth("target") == 0 then
			target_health_perc:SetText("Dead");
		else
			target_health_perc:SetText(format_percentage_number(UnitHealth("target"), UnitHealthMax("target")).."%");
		end
	end
	if UnitPowerMax("target") > 0 and UnitPowerMax("target") > 999 then
		target_energy_perc:SetText(format_percentage_number(UnitPower("target"), UnitPowerMax("target")).."%");
	end
	
	target_absorb_bar:SetMinMaxValues(0, UnitHealthMax("target"));
	target_absorb_bar:SetValue(UnitHealth("target") + UnitGetTotalAbsorbs("target"));
	
	if UnitHealth("target") + UnitGetTotalAbsorbs("target") > UnitHealthMax("target") then
		target_overabsorb_texture:SetAlpha(1);
	else
		target_overabsorb_texture:SetAlpha(0);
	end
	
	if UnitName("target") ~= nil then
		target_name_text:SetText(UnitName("target"));
	else
		target_name_text:SetText("");
	end
	
	tarlvlvalue = UnitLevel("target");
	if tarlvlvalue == -1 then
		target_level_text:SetText("Boss");
	elseif tarlvlvalue == 0 then
		target_level_text:SetText("");
	else
		target_level_text:SetText("L:"..tarlvlvalue.."");
	end
end

local rune_texture_names =
{
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy"
};
local rune_frames = nil;
local rune_background_textures = nil;
local rune_cooldowns = nil;
local rune_cooldown_textures = nil;
local rune_rings = nil;
local rune_ring_textures = nil;
local rune_texts = nil;
local rune_ids = {1, 2, 5, 6, 3, 4};
local rune_anim = {0, 0, 0, 0, 0, 0};
local function setup_runes()
	if rune_frames == nil then
		
		base_frame = frames[get_frame("runes")];
		
		rune_frames = {};
		rune_background_textures = {};
		rune_cooldowns = {};
		rune_cooldown_textures = {};
		rune_rings = {};
		rune_ring_textures = {};
		rune_texts = {};
		
		for i = 1,6 do
			rune_frames[i] = CreateFrame("Frame", "Rune"..i.."BG", base_frame.frame);
			rune_frames[i]:SetPoint("CENTER", base_frame.frame, "CENTER", -(base_frame.width / 2) - (base_frame.height / 2) * 0.8 + (base_frame.width / 6) * i, 0);
			rune_frames[i]:SetWidth(base_frame.height);
			rune_frames[i]:SetHeight(base_frame.height);
			rune_frames[i]:SetFrameLevel(16);
			
			rune_background_textures[i] = rune_frames[i]:CreateTexture("ARTWORK");
			rune_background_textures[i]:SetAllPoints();
			rune_background_textures[i]:SetTexture(0, 0, 0); 
			rune_background_textures[i]:SetAlpha(1);
			
			rune_cooldowns[i] = CreateFrame("Frame", "Rune"..i.."CD", rune_frames[i]);
			rune_cooldowns[i]:SetPoint("CENTER", rune_frames[i], "CENTER", 0, 1);
			rune_cooldowns[i]:SetWidth(base_frame.height * 0.65);
			rune_cooldowns[i]:SetHeight(base_frame.height * 0.65);
			rune_cooldowns[i]:SetFrameLevel(17);
			rune_cooldown_textures[i] = CreateFrame("Cooldown", "Rune"..i.."CDAnim", rune_cooldowns[i], "CooldownFrameTemplate");
			rune_cooldown_textures[i]:SetFrameLevel(18);
			
			rune_rings[i] = CreateFrame("Frame", "Rune"..i.."Ring", rune_frames[i]);
			rune_rings[i]:SetPoint("TOPLEFT", rune_frames[i], "TOPLEFT", 0, 0);
			rune_rings[i]:SetWidth(base_frame.height);
			rune_rings[i]:SetHeight(base_frame.height);
			rune_rings[i]:SetFrameLevel(19);
			
			rune_ring_textures[i] = rune_rings[i]:CreateTexture("ARTWORK");
			rune_ring_textures[i]:SetAllPoints();
			rune_ring_textures[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring");
			rune_ring_textures[i]:SetAlpha(1);
			
			rune_texts[i] = rune_rings[i]:CreateFontString("Runic Power Number", "ARTWORK", "TextStatusBarText");
			rune_texts[i]:SetPoint("CENTER", rune_rings[i], "CENTER", 0, 0);
			rune_texts[i]:SetText(0);
			
		end
	end
end
local function update_runes()
	setup_runes();
	
	for i = 1,6 do
		if GetRuneType(rune_ids[i]) == 4 then
			rune_background_textures[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death");
		else
			rune_background_textures[i]:SetTexture(rune_texture_names[i]);
		end
		
		rune_start, rune_duration = GetRuneCooldown(rune_ids[i]);
		
		if umb_timers == true then
			if rune_start == 0 then
				rune_texts[i]:SetText("");
			else
				rune_texts[i]:SetText(math.floor((rune_duration - (GetTime() - rune_start)) + 0.5));
			end
		else
			rune_texts[i]:SetText("");
		end
		
		if rune_start ~= 0 then
			rune_cooldown_textures[i]:SetCooldown(rune_start, rune_duration);
			rune_anim[i] = 1;
		else
			if rune_anim[i] == 1 then
				rune_anim[i] = 0;
				rune_cooldown_textures[i]:SetCooldown(0, 0);
			end
		end
	end
end

local soulreaper_frame = nil;
local soulreaper_texture = nil;
local soulreaper_alpha = 0;
local soulreaper_anim = 0;
local function setup_soulreaper()
	if soulreaper_frame == nil then
		
		base_frame = frames[get_frame("runes")];
		
		soulreaper_frame = CreateFrame("Frame", "Backgroundframe", base_frame.frame);
		soulreaper_frame:SetPoint("CENTER", base_frame.frame, "CENTER", 0, 0);
		soulreaper_frame:SetWidth(384); 
		soulreaper_frame:SetHeight(192);
		soulreaper_frame:SetFrameLevel(14);
		
		soulreaper_texture = soulreaper_frame:CreateTexture("ARTWORK");
		soulreaper_texture:SetAllPoints();
		soulreaper_texture:SetTexture("Textures\\Spellactivationoverlays\\Shadow_of_Death");
		soulreaper_texture:SetAlpha(1);
		
	end
end
local function update_soulreaper()
	setup_soulreaper();
	
	displayAlert = false;
	for i = 1, 3 do
		if IsSpellKnown(soul_reaper_ids[i]) then
			start, duration, _ = GetSpellCooldown(soul_reaper_ids[i])
			if duration < 5.9 or duration > 6.1 then
				displayAlert = true;
				break;
			end
		end
	end
	
	if UnitHealthMax("target") > 0 and UnitHealth("target") > 0 and UnitCanAttack("player", "target") and UnitAffectingCombat("player") == 1 then
		if UnitHealth("target")/(UnitHealthMax("target")/100) > 35 and displayAlert == true then
			displayAlert = false;
		end
	else
		displayAlert = false;
	end
	
	if frame_locked == 0 then
		displayAlert = true;
	end
	
	if umb_soulreaper == false then
		displayAlert = false;
	end
	
	if displayAlert == true then
		soulreaper_alpha = soulreaper_alpha + delta_time * 4;
	else
		soulreaper_alpha = soulreaper_alpha - delta_time * 4;
	end
	
	soulreaper_anim = soulreaper_anim + delta_time * 3;
	alertSizeScale = (math.sin(soulreaper_anim) + 1) / 2;
	
	if soulreaper_alpha < 0 then soulreaper_alpha = 0; end
	if soulreaper_alpha > 1 then soulreaper_alpha = 1; end
	
	soulreaper_frame:SetWidth(253.44 + 25.344 * alertSizeScale); 
	soulreaper_frame:SetHeight(126.72 + 12.672 * alertSizeScale);
	
	soulreaper_texture:SetAlpha(soulreaper_alpha);
end

local health_frame = nil;
local health_background = nil;
local health_text = nil;
local health_bar = nil;
local health_absorb_frame = nil;
local health_absorb_texture = nil;
local health_absorb_bar = nil;
local health_overabsorb_frame = nil;
local health_overabsorb_texture = nil;
local health_perc = nil;
local function setup_health()
	if health_frame == nil then
		
		base_frame = frames[get_frame("health")];
		
		health_frame = CreateFrame("Frame", nil, base_frame.frame);
		health_frame:SetPoint("TOP", base_frame.frame, "TOP", 0, 0);
		health_frame:SetWidth(base_frame.width); 
		health_frame:SetHeight(base_frame.height);
		
		health_background = health_frame:CreateTexture("ARTWORK");
		health_background:SetAllPoints();
		health_background:SetTexture(0, 0.4, 0);
		health_background:SetAlpha(0.4);
		
		health_absorb_bar = CreateFrame("StatusBar", nil, health_frame);
		health_absorb_bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
		health_absorb_bar:GetStatusBarTexture():SetHorizTile(false);
		health_absorb_bar:SetMinMaxValues(0, 100);
		health_absorb_bar:SetWidth(base_frame.width);
		health_absorb_bar:SetHeight(base_frame.height);
		health_absorb_bar:SetPoint("CENTER", health_frame, "CENTER", 0, 0); 
		health_absorb_bar:SetStatusBarColor(1, 1, 1);
		health_absorb_bar:SetFrameLevel(19);
		
		health_absorb_frame = CreateFrame("Frame", nil, health_frame);
		health_absorb_frame:SetPoint("TOP", health_frame, "TOP", 0, 0);
		health_absorb_frame:SetWidth(base_frame.width); 
		health_absorb_frame:SetHeight(base_frame.height);
		health_absorb_frame:SetFrameLevel(20);
		
		health_absorb_texture = health_absorb_frame:CreateTexture("ARTWORK");
		health_absorb_texture:SetAllPoints();
		health_absorb_texture:SetTexture("Interface\\RaidFrame\\Shield-Overlay", true);
		health_absorb_texture:SetTexCoord(0, -3, 0, 1);
		
		health_overabsorb_frame = CreateFrame("Frame", nil, health_frame);
		health_overabsorb_frame:SetPoint("TOPRIGHT", health_frame, "TOPRIGHT", 3, 0);
		health_overabsorb_frame:SetWidth(16); 
		health_overabsorb_frame:SetHeight(base_frame.height);
		health_overabsorb_frame:SetFrameLevel(22);
		
		health_overabsorb_texture = health_overabsorb_frame:CreateTexture("ARTWORK");
		health_overabsorb_texture:SetAllPoints();
		health_overabsorb_texture:SetTexture("Interface\\RaidFrame\\Absorb-Overabsorb");
		health_overabsorb_texture:SetBlendMode("ADD");
		
		health_bar = CreateFrame("StatusBar", nil, health_frame);
		health_bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
		health_bar:GetStatusBarTexture():SetHorizTile(false);
		health_bar:SetMinMaxValues(0, 100);
		health_bar:SetWidth(base_frame.width);
		health_bar:SetHeight(base_frame.height);
		health_bar:SetPoint("CENTER", health_frame, "CENTER", 0, 0); 
		health_bar:SetStatusBarColor(0, 0.8, 0);
		health_bar:SetFrameLevel(21);
		
		health_text = health_bar:CreateFontString("Runic Power Number", "ARTWORK", "TextStatusBarText");
		health_text:SetPoint("CENTER", health_bar, "CENTER", 0, 0);
		health_text:SetText(0);
		
		health_perc = health_bar:CreateFontString("Hit Points Percentage", "ARTWORK", "GameFontNormalSmall");
		health_perc:SetPoint("CENTER", health_bar, "CENTER", base_frame.width / 2 + 15, 0);
		health_perc:SetText(0);
		
	end
end
local function update_health()
	setup_health();
	
	health_bar:SetMinMaxValues(0, UnitHealthMax("player"));
	health_bar:SetValue(UnitHealth("player"));
	
	health_text:SetText(""..format_big_number(UnitHealth("player")).." / "..format_big_number(UnitHealthMax("player")).."");
	health_perc:SetText(format_percentage_number(UnitHealth("player"), UnitHealthMax("player")).."%");
	
	health_absorb_bar:SetMinMaxValues(0, UnitHealthMax("player"));
	health_absorb_bar:SetValue(UnitHealth("player") + UnitGetTotalAbsorbs("player"));
	
	if UnitHealth("player") + UnitGetTotalAbsorbs("player") > UnitHealthMax("player") then
		health_overabsorb_texture:SetAlpha(1);
	else
		health_overabsorb_texture:SetAlpha(0);
	end
	
end

local runic_frame = nil;
local runic_background = nil;
local runic_bar = nil;
local runic_text = nil;
local presence_frame = nil;
local presence_background = nil;
local function setup_runic()
	if runic_frame == nil then
	
		base_frame = frames[get_frame("runic")];
		
		runic_frame = CreateFrame("Frame", nil, base_frame.frame);
		runic_frame:SetPoint("TOP", base_frame.frame, "TOP", 0, 0);
		runic_frame:SetWidth(base_frame.width); 
		runic_frame:SetHeight(base_frame.height);
		
		power_type, power_token = UnitPowerType("player");
		runic_background = runic_frame:CreateTexture("ARTWORK");
		runic_background:SetAllPoints();
		runic_background:SetTexture(PowerBarColor[power_token]["r"], PowerBarColor[power_token]["g"], PowerBarColor[power_token]["b"]);
		runic_background:SetAlpha(0.2);
		
		runic_bar = CreateFrame("StatusBar", nil, runic_frame);
		runic_bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
		runic_bar:GetStatusBarTexture():SetHorizTile(false);
		runic_bar:SetMinMaxValues(0, 100);
		runic_bar:SetWidth(base_frame.width);
		runic_bar:SetHeight(base_frame.height);
		runic_bar:SetPoint("CENTER", runic_frame, "CENTER", 0, 0); 
		runic_bar:SetStatusBarColor(PowerBarColor[power_token]["r"], PowerBarColor[power_token]["g"], PowerBarColor[power_token]["b"]);
		
		runic_text = runic_bar:CreateFontString("Runic Power Number", "ARTWORK", "TextStatusBarText");
		runic_text:SetPoint("CENTER", runic_bar, "CENTER", 0, 0);
		runic_text:SetText(0);
		presence_frame = CreateFrame("Frame", "Backgroundframe", runic_frame)
		presence_frame:SetPoint("CENTER", runic_frame, "CENTER", -72, 0);
		presence_frame:SetWidth(base_frame.height); 
		presence_frame:SetHeight(base_frame.height);
		presence_background = presence_frame:CreateTexture("ARTWORK");
		presence_background:SetAllPoints();
		presence_background:SetTexture(0, 0, 0); 
		presence_background:SetAlpha(1);
		
	end
end
local function update_runic()
	setup_runic();
	
	runic_bar:SetMinMaxValues(0, UnitPowerMax("player", 6));
	runic_bar:SetValue(UnitPower("player", 6));
	runic_text:SetText(UnitPower("player", 6));
	
	active_presence = -1;
	i = 1;
	while true do
		local name, _, icon, _, _, _, _, _, _, _, id = UnitBuff("player", i);
		if name then
			if id == blood_presence_id then
				active_presence = 1;
				break;
			end
			if id == frost_presence_id then
				active_presence = 2;
				break;
			end
			if id == unholy_presence_id then
				active_presence = 3;
				break;
			end
		else
			break;
		end
		
		i = i + 1;
	end
	
	if active_presence == -1 then
		presence_background:SetTexture(0, 0, 0); 
		presence_background:SetAlpha(0);
	else
		presence_background:SetAlpha(1);
		if active_presence == 1 then
			presence_background:SetTexture("Interface\\Icons\\spell_deathknight_bloodpresence");
			presence_background:SetAlpha(1);
		elseif active_presence == 2 then
			presence_background:SetTexture("Interface\\Icons\\spell_deathknight_frostpresence"); 
			presence_background:SetAlpha(1);
		elseif active_presence == 3 then
			presence_background:SetTexture("Interface\\Icons\\spell_deathknight_unholypresence"); 
			presence_background:SetAlpha(1);
		end
	end
end

local swingtimer_frame = nil;
local swingtimer_background = nil;
local swingtimer_line = nil;
local swingtimer_line_texture = nil;
local swingtimer_value = GetTime() - 50000;
local function setup_swingtimer()
	if swingtimer_background == nil then
	
		base_frame = frames[get_frame("swingtimer")];
		
		swingtimer_frame = CreateFrame("Frame", nil, base_frame.frame);
		swingtimer_frame:SetPoint("TOP", base_frame.frame, "TOP", 0, 0);
		swingtimer_frame:SetWidth(base_frame.width); 
		swingtimer_frame:SetHeight(base_frame.height);
		
		swingtimer_background = swingtimer_frame:CreateTexture("ARTWORK");
		swingtimer_background:SetAllPoints();
		swingtimer_background:SetTexture(0.7, 0.7, 0.7);
		swingtimer_background:SetAlpha(0.4);
		
		swingtimer_line = CreateFrame("Frame", nil, swingtimer_frame);
		swingtimer_line:SetPoint("TOPLEFT", swingtimer_frame, "TOPLEFT", 0, 0);
		swingtimer_line:SetWidth(3); 
		swingtimer_line:SetHeight(base_frame.height);
		
		swingtimer_line_texture = swingtimer_line:CreateTexture("ARTWORK");
		swingtimer_line_texture:SetAllPoints();
		swingtimer_line_texture:SetTexture(0, 1, 1);
		
	end
end
local function update_swingtimer()
	setup_swingtimer();
	
	mainhandspeed, offhandSpeed = UnitAttackSpeed("player");
	
	if offhandSpeed ~= nil or IsSpellKnown(killing_machine_id) == false then
		swingtimer_frame:Hide();
		return;
	else
		swingtimer_frame:Show();
	end
	
	value = 0;
	max_width = math.floor(swingtimer_frame:GetWidth());
	if UnitAffectingCombat("player") ~= 1 then
		value = max_width + 55;
	else
		value = math.floor(((GetTime() - swingtimer_value) / mainhandspeed) * max_width);
	end
	
	if value < 0 or value >= max_width - 3 then
		swingtimer_line:Hide();
	else
		swingtimer_line:Show();
		swingtimer_line:SetPoint("TOPLEFT", swingtimer_frame, "TOPLEFT", value, 0);
	end
end

local bloodtap_frame = nil;
local bloodtap_texture = nil;
local bloodtap_text = nil;
local function setup_bloodtap()
	if bloodtap_frame == nil then
		
		base_frame = frames[get_frame("bloodtap")];
	
		bloodtap_frame = CreateFrame("Frame", "Backgroundframe", base_frame.frame);
		bloodtap_frame:SetPoint("CENTER", base_frame.frame, "CENTER", -base_frame.height / 2, 0);
		bloodtap_frame:SetWidth(base_frame.height); 
		bloodtap_frame:SetHeight(base_frame.height);
		
		bloodtap_texture = bloodtap_frame:CreateTexture("ARTWORK");
		bloodtap_texture:SetAllPoints();
		bloodtap_texture:SetTexture("Interface\\Icons\\spell_deathknight_bloodtap");

		bloodtap_text = bloodtap_frame:CreateFontString("Target Name", "ARTWORK", "GameFontNormalSmall");
		bloodtap_text:SetPoint("CENTER", bloodtap_frame, "CENTER", base_frame.height, 0);
		bloodtap_text:SetText(0);
	
	end
end
local function update_bloodtap()
	setup_bloodtap();
	
	if IsSpellKnown(blood_tap_id) or frame_locked == 0 then
		btName = GetSpellInfo(blood_tap_id);
		
		btCount = 0;
		i = 1;
		while true do
			name, _, _, count, _, _, _, _, _, _, id = UnitBuff("player", i);
			if name == nil then
				break;
			end
			if id == blood_charge_id then
				btCount = count;
				break;
			end
			i = i + 1;
		end
		
		if btCount < 5 then
			bloodtap_texture:SetAlpha(0.1);
		else
			bloodtap_texture:SetAlpha(1);
		end
		
		if btCount == 0 then
			bloodtap_text:SetText("");
		else
			bloodtap_text:SetText(btCount);
		end
		
		bloodtap_frame:Show();
	else
		bloodtap_frame:Hide();
	end
		
end

-- On update
local isdragging = false;
local isscaling = false;
local frame_selected = -1;
local xDragStart = 0;
local yDragStart = 0;
umber_main_frame:SetScript("OnUpdate", function(self, elapsed)
	
	calculate_delta_time();
	
	update_alpha();

	if frame_locked == 0 then
		for i = 1, table.getn(frames) do frames[i].frame:EnableMouse(true); end
		
		if isdragging == false and isscaling == false then
			frame_selected = -1;
			for i = 1, table.getn(frames) do
				if get_frame_enabled(frames[i].name) == true then
					if GetMouseFocus() == frames[i].frame then frame_selected = i; end
				end
			end
			if IsMouseButtonDown(1) == 1 then
				if frame_selected ~= -1 then
					xDragStart, yDragStart = GetCursorPosition();
					xDragStart = xDragStart - umb_x;
					yDragStart = yDragStart - umb_y;
					isdragging = true;
				end
			elseif IsMouseButtonDown(2) == 1 then
				if frame_selected ~= -1 then
					xDragStart, yDragStart = GetCursorPosition();
					isscaling = true;
				end
			end
		end
		
		if isdragging and IsMouseButtonDown(1) ~= 1 then isdragging = false end;
		if isscaling and IsMouseButtonDown(2) ~= 1 then isscaling = false end;
		
		if isdragging == true then
			umb_x, umb_y = GetCursorPosition();
			umb_x = umb_x - xDragStart;
			umb_y = umb_y - yDragStart;
		elseif isscaling == true then
			current_scale = get_frame_size(frames[frame_selected].name);
			xPos, yPos = GetCursorPosition();
			distance = (yDragStart - yPos) / 50;
			current_scale = current_scale - distance;
			if current_scale < 0.5 then current_scale = 0.5 end
			if current_scale > 3 then current_scale = 3 end
			set_frame_size(frames[frame_selected].name, current_scale);
			xDragStart, yDragStart = GetCursorPosition();
		end
	else
		for i = 1, table.getn(frames) do frames[i].frame:EnableMouse(false); end
	end
	
	for i = 1, table.getn(frames) do
		if get_frame_enabled(frames[i].name) == true then
			frames[i].frame:SetScale(get_frame_size(frames[i].name));
			frames[i].frame:Show();
		else
			frames[i].frame:Hide();
		end
	end
	
	largest_width = 1;
	total_height = 1;
	frame_current_height = 0;
	for i = 1, table.getn(frames) do
		if get_frame_enabled(frames[i].name) == true then
			if frames[i].width >= largest_width then largest_width = frames[i].width; end;
			total_height = total_height + frames[i].height * get_frame_size(frames[i].name);
			frames[i].frame:SetPoint("TOP", umber_main_frame, "TOP", 0, frame_current_height / get_frame_size(frames[i].name));
			frame_current_height = frame_current_height - frames[i].height * get_frame_size(frames[i].name);
		end
	end
	
	umber_drag_frame:SetWidth(largest_width);
	umber_drag_frame:SetHeight(total_height);
	umber_main_frame:SetPoint("TOP", umber_drag_frame, "TOP", 0, 0);
	
	umber_drag_frame:ClearAllPoints();
	umber_drag_frame:SetPoint("CENTER", umb_x, umb_y);
	
	update_diseases();
	update_target();
	update_runes();
	update_soulreaper();
	update_health();
	update_runic();
	update_swingtimer();
	update_bloodtap();
end)

-- On events
umber_main_frame:RegisterEvent("ADDON_LOADED");
umber_main_frame:SetScript("OnEvent", function(self, event, ...)
	
	if event == "ADDON_LOADED" then
		umber_main_frame:UnregisterEvent("ADDON_LOADED");
		umber_setup();
		umber_main_frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	end
	
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _, type, _, sourceGUID, _, _, _, destGUID, _, _, _ = ...;
		if type == "SWING_DAMAGE" and sourceGUID == UnitGUID("player") and destGUID == UnitGUID("target") then
			swingtimer_value = GetTime();
		end
	end
end)

-- Slash commands
local header_start = "|cFFFFA07AUmberRunes: |cffffffff";
local command_color = "|cFF00FFFF";
local text_color = "|cffffffff";
SLASH_UMBER1 = '/umber';
local function handler(msg, editbox)
local command, rest = msg:match("^(%S*)%s*(.-)$")
	if command == "lock" then
		if frame_locked == 1 then frame_locked = 0; print(header_start.."Frame unlocked.") else frame_locked = 1; print(header_start.."Frame locked.") end;
	elseif command == "reset" then
		umb_x = 0; umb_y = 0;
		for i = 1, table.getn(frames) do umb_data["frame_"..frames[i].name.."_size"] = 1; end
		for i = 1, table.getn(frames) do umb_data["frame_"..frames[i].name.."_enabled"] = true; end
		print(header_start.."Frame reset.");
	elseif command == "setscale" then
		scale = tonumber(rest);
		if scale ~= nil then
			if scale >= 0.5 and scale <= 3 then
				for i = 1, table.getn(frames) do umb_data["frame_"..frames[i].name.."_size"] = scale; end
			else
				print(header_start.."Use a number between 0.5 and 3 to set the scale.");
			end
		else
			print(header_start.."Use a number between 0.5 and 3 to set the scale.");
		end
	elseif command == "combat" then
		if umb_combat == true then umb_combat = false; print(header_start.."Will remain visible while out of combat.") else umb_combat = true; print(header_start.."Will hide while out of combat.") end;
	elseif command == "togglehealth" then
		set_string = "frame_health_enabled";
		if umb_data[set_string] == true then
			umb_data[set_string] = false;
			print(header_start.."Hiding Health bar.");
		else
			umb_data[set_string] = true;
			print(header_start.."Showing Health bar.");
		end
	elseif command == "togglerunic" then
		set_string = "frame_runic_enabled";
		if umb_data[set_string] == true then
			umb_data[set_string] = false;
			print(header_start.."Hiding Runic Power bar.");
		else
			umb_data[set_string] = true;
			print(header_start.."Showing Runic Power bar.");
		end
	elseif command == "toggletarget" then
		set_string1 = "frame_target_enabled";
		set_string2 = "frame_targetname_enabled";
		if umb_data[set_string1] == true then
			umb_data[set_string1] = false;
			umb_data[set_string2] = false;
			print(header_start.."Hiding target info.");
		else
			umb_data[set_string1] = true;
			umb_data[set_string2] = true;
			print(header_start.."Showing target info.");
		end
	elseif command == "togglediseases" then
		set_string = "frame_diseases_enabled";
		if umb_data[set_string] == true then
			umb_data[set_string] = false;
			print(header_start.."Hiding diseases tracking.");
		else
			umb_data[set_string] = true;
			print(header_start.."Showing diseases tracking.");
		end
	elseif command == "toggleswingtimer" then
		set_string = "frame_swingtimer_enabled";
		if umb_data[set_string] == true then
			umb_data[set_string] = false;
			print(header_start.."Hiding swingtimer.");
		else
			umb_data[set_string] = true;
			print(header_start.."Showing swingtimer.");
		end
	elseif command == "togglebloodtap" then
		set_string = "frame_bloodtap_enabled";
		if umb_data[set_string] == true then
			umb_data[set_string] = false;
			print(header_start.."Hiding Blood Tap tracking.");
		else
			umb_data[set_string] = true;
			print(header_start.."Showing Blood Tap tracking.");
		end
	elseif command == "togglesoulreaper" then
		if umb_soulreaper == true then
			umb_soulreaper = false;
			print(header_start.."Hiding Soul Reaper alert.");
		else
			umb_soulreaper = true;
			print(header_start.."Showing Soul Reaper alert.");
		end
	elseif command == "toggletimers" then
		if umb_timers == true then
			umb_timers = false;
			print(header_start.."Hiding Rune timers.");
		else
			umb_timers = true;
			print(header_start.."Showing Rune timers.");
		end
	else
		print("|cFFFFA07AUmberRunes:");
		print(command_color.."/umber lock - "..text_color.."Lock/unlock the main frame.");
		print(command_color.."/umber reset - "..text_color.."Reset the position of the main frame.");
		print(command_color.."/umber setscale - "..text_color.."Set the scale of all components. (Value between 0.5 and 3, 1 is default).");
		print(command_color.."/umber combat - "..text_color.."Toggle hiding when out of combat.");
		print(command_color.."/umber togglehealth - "..text_color.."Toggle the Player Health bar on/off.");
		print(command_color.."/umber togglerunic - "..text_color.."Toggle the Runic Power bar on/off.");
		print(command_color.."/umber toggletarget - "..text_color.."Toggle the target info on/off.");
		print(command_color.."/umber togglediseases - "..text_color.."Toggle the disease tracking on/off.");
		print(command_color.."/umber toggleswingtimer - "..text_color.."Toggle the auto attack swingtimer on/off.");
		print(command_color.."/umber togglebloodtap - "..text_color.."Toggle the Blood Tap tracking on/off.");
		print(command_color.."/umber togglesoulreaper - "..text_color.."Toggle the Soul Reaper alert on/off.");
		print(command_color.."/umber toggletimers - "..text_color.."Toggle Rune timers on/off.");
	end
end
SlashCmdList["UMBER"] = handler;

-- Blizz Runes
RuneButtonIndividual1:Hide();
RuneButtonIndividual2:Hide();
RuneButtonIndividual3:Hide();
RuneButtonIndividual4:Hide();
RuneButtonIndividual5:Hide();
RuneButtonIndividual6:Hide();